#include "can_ids.h"

void decode_can(CANdata msg, {{spec.signature}} *can) {
switch (msg.dev_id) {
{% for device in spec.devices.values() %}
	case {{device.id}}:
		#ifndef {{device.name.upper()}}
		#ifndef NO_{{device.name.upper()}}
		decode_{{device.name}}(msg, &(can->{{device.name}}));
		#endif
		#endif
		break;
		{%- endfor %}

}
		decode_{{spec.common.name}}(msg, &(can->{{spec.common.name}}));
		decode_can_callback(msg);
}

void __attribute__((weak)) decode_can_callback(CANdata msg) {
	return;
}
